#!/usr/local/bin/python
# -*- coding: utf-8 -*-
'''
Created on 2010/10/07
 SHsSL main.
@author: toru kageyama <info@comona.co.jp>
'''
# imports.
import cgi
import os
import socket
from ftplib import FTP  # FTP module.
# ShsSL modules.
from settings import FTP_SERVER, SSL_SERVER
from changes import chmod
from list import list, connect
from files import rmd, delete_file, rename_file, mkd
from retrieve import retrieve_file
from store import store_file
from xmlformatter import XmlFormatter

################################################################################
# CGI starts here.
# check method, only POST is available.
formatter = XmlFormatter()
https_host = socket.gethostbyname(SSL_SERVER)
if os.environ['REMOTE_ADDR'] != https_host:
    raise Exception

is_connect = False
try:
    # request parameters.
    form = cgi.FieldStorage()

    # FTP connect.
    ftp = FTP(FTP_SERVER)
    is_connect = True
    # login.
    ftp.login(form['user'].value, form['password'].value)
    formatter.set_login_result(True)
    # login success.
    # change directory.
    dir = ftp.cwd(form['dir'].value)
    # if error returned, do PWD command.
    pwd = ftp.pwd()
    if form['dir'].value[0] != '/':
        formatter.set_current_directory(pwd)
    else:
        formatter.set_current_directory(form['dir'].value)

    # do command from here.
    cmd = form['cmd'].value
    formatter.set_command_name(cmd)
    if cmd == 'LIST':
        list(ftp, form, formatter, formatter.get_current_directory())
    elif cmd == 'RMD':
        rmd(ftp, form, formatter)
    elif cmd == 'RM':
        delete_file(ftp, form, formatter)
    elif cmd == 'MKD':
        mkd(ftp, form, formatter)
    elif cmd == 'REN':
        rename_file(ftp, form, formatter)
    elif cmd == 'CHMOD':
        chmod(ftp, form, formatter)
    elif cmd == 'STOR':
        store_file(ftp, form, formatter)
    elif cmd == 'RETR':
        retrieve_file(ftp, form, formatter)
    elif cmd == 'CONN': # connect.
        connect(ftp, form, formatter)

except:
    formatter.set_command_result(False)

# quit from FTP server.
if is_connect:
    ftp.quit()

# print out XML.
formatter.print_out()
